//************************************************************************
//**    PinoLite                                                        **
//**    Rg[Avbg                                          **
//**                                                                    **
//**    F  '97/06/13    Ver.1.00  (Orange Wine,Inc.) 쐬  **
//**                                                                    **
//************************************************************************

// WXg
#define PINO_REG_KEY			"System\\CurrentControlSet\\Services\\Class\\PinoLite"
#define	PINO_REG_INTBASE_STR	"IntMemBaseAddress"
#define	PINO_REG_EXTBASE_STR	"ExtMemBaseAddress"
#define	PINO_REG_IO1BASE_STR	"Io1BaseAddress"
#define	PINO_REG_IO2BASE_STR	"Io2BaseAddress"
#define	PINO_REG_INTBASE_VAL	0xe9000000
#define	PINO_REG_EXTBASE_VAL	0xea000000
#define	PINO_REG_IO1BASE_VAL	0xc000
#define	PINO_REG_IO2BASE_VAL	0xc400

#include <windows.h>
#include <cpl.h>
#include <commdlg.h>
#include <stdio.h>
#include "pinocpl.h"
#include "resource.h"

// Rg[Avbg
typedef struct tagApplets
{
    int icon;           // hbnm\[X
    int namestring;     // 
    int descstring;     // 
    int dlgtemplate;    // _CAOev[g
    DLGPROC dlgfn;      // _CAO
} APPLETS;

APPLETS RunApplet =
{
    RUN_ICON, RUN_NAME, RUN_DESC, RUN_DLG, RunDlgProc,
} ;

WNDPROC wpOrigIntEditProc; 
WNDPROC wpOrigExtEditProc; 
WNDPROC wpOrigIo1EditProc; 
WNDPROC wpOrigIo2EditProc; 
LRESULT APIENTRY EditSubclassProcMem(HWND hwnd, UINT uMsg, WPARAM wParam, LPARAM lParam) ;
LRESULT APIENTRY EditSubclassProcIo(HWND hwnd, UINT uMsg, WPARAM wParam, LPARAM lParam) ;

HANDLE  hModule = NULL;
char    szCtlPanel[30];
HKEY	hParamKey ;
DWORD	IntBaseAddress ;
DWORD	ExtBaseAddress ;
DWORD	Io1BaseAddress ;
DWORD	Io2BaseAddress ;
HWND	hwndInt ;
HWND	hwndExt ;
HWND	hwndIo1 ;
HWND	hwndIo2 ;
/****************************************************************************
*
*    FUNCTION: DllMain(PVOID, ULONG, PCONTEXT)
*
*    PURPOSE: Win 32 Initialization DLL
*
*    COMMENTS:
*
*
****************************************************************************/

BOOL WINAPI DllMain(IN PVOID hmod, IN ULONG ulReason, IN PCONTEXT pctx OPTIONAL)
{
	if (ulReason != DLL_PROCESS_ATTACH) {
		return TRUE;
	}
	else {
		hModule = hmod;
	}

    return TRUE;

    UNREFERENCED_PARAMETER(pctx);
}
//*************************************************************
//** Avbg                                        **
//**                                                         **
//** LvV[h                                **
//*************************************************************
BOOL InitRuncplApplet (HWND hwndParent)
{
	LoadString (hModule, CPCAPTION, szCtlPanel, sizeof(szCtlPanel));

	return TRUE;

	UNREFERENCED_PARAMETER(hwndParent);
}


//*************************************************************
//** AvbgI                                          **
//**                                                         **
//** I                                                **
//*************************************************************
void TermRunApplet()
{
	return;
}



//*************************************************************
//** R[obN                                            **
//**                                                         **
//** Rg[pl̃bZ[W                  **
//*************************************************************
LONG CALLBACK CPlApplet (HWND hwndCPL, UINT uMsg, LONG lParam1, LONG lParam2)
{
	LPNEWCPLINFO lpNewCPlInfo;
	// JE^
	static iInitCount = 0;
            
    switch (uMsg) {
		case CPL_INIT:
			// v
			if (!iInitCount) {
				// ߂Ă̏ꍇ͏
				if (!InitRuncplApplet(hwndCPL)) {
					return FALSE;
				}
			}
			iInitCount++;
			return TRUE;

        case CPL_GETCOUNT:
			// ɂPԂ
			return (LONG)1;
			break;

		case CPL_NEWINQUIRE: 
			// \[X̓ǂݍ
			lpNewCPlInfo = (LPNEWCPLINFO) lParam2;
			lpNewCPlInfo->dwSize = (DWORD) sizeof(NEWCPLINFO);
			lpNewCPlInfo->dwFlags = 0;
			lpNewCPlInfo->dwHelpContext = 0;
			lpNewCPlInfo->lData = 0;
			// Rg[plɕ\ACR
			lpNewCPlInfo->hIcon = LoadIcon (hModule,
				(LPCTSTR) MAKEINTRESOURCE(RunApplet.icon));
			lpNewCPlInfo->szHelpFile[0] = '\0';
			// Rg[plɕ\閼O
			LoadString (hModule, RunApplet.namestring,
						lpNewCPlInfo->szName, 32);
			LoadString (hModule, RunApplet.descstring,
						lpNewCPlInfo->szInfo, 64);

			break;

		case CPL_SELECT:
         // AvP[ṼACRI
			break;

		case CPL_DBLCLK:
			// Rg[plŃACR_uNbN
            // _CAOJn
			DialogBox (hModule,
					MAKEINTRESOURCE(RunApplet.dlgtemplate),
					hwndCPL,
					RunApplet.dlgfn);
			break;

		case CPL_STOP:              // sent once per app. before CPL_EXIT
            break;

		case CPL_EXIT:              // sent once before FreeLibrary called
			iInitCount--;
			if (!iInitCount) {
				TermRunApplet();
			}
			break;

		default:
			break;
	}
	return 0;
}
//************************************************************
//** hCõp[^WXg擾					**
//**														**
//************************************************************
BOOL	GetRegistry(void)
{
	DWORD	ParamLength = sizeof(DWORD) ;

	IntBaseAddress = PINO_REG_INTBASE_VAL ;
	ExtBaseAddress = PINO_REG_EXTBASE_VAL;
	Io1BaseAddress = PINO_REG_IO1BASE_VAL;
	Io2BaseAddress = PINO_REG_IO2BASE_VAL;

	// Internal Base Mamory Address
	ParamLength = sizeof(DWORD) ;
	if (RegQueryValueEx(hParamKey, PINO_REG_INTBASE_STR,
			NULL, NULL,	(LPBYTE)&IntBaseAddress, &ParamLength) != ERROR_SUCCESS) {
			IntBaseAddress = PINO_REG_INTBASE_VAL ;
			if(RegSetValueEx(hParamKey, PINO_REG_INTBASE_STR, 0, REG_DWORD,
						(LPBYTE)&IntBaseAddress, sizeof(DWORD)) != ERROR_SUCCESS) {
				return FALSE ;
			}
	}
	// External Base Mamory Address
	ParamLength = sizeof(DWORD) ;
	if (RegQueryValueEx(hParamKey, PINO_REG_EXTBASE_STR,
			NULL, NULL,	(LPBYTE)&ExtBaseAddress, &ParamLength) != ERROR_SUCCESS) {
			ExtBaseAddress = PINO_REG_EXTBASE_VAL ;
			if(RegSetValueEx(hParamKey, PINO_REG_EXTBASE_STR, 0, REG_DWORD,
						(LPBYTE)&ExtBaseAddress, sizeof(DWORD)) != ERROR_SUCCESS) {
				return FALSE ;
			}
	}
	// IO1 Base Address
	ParamLength = sizeof(DWORD) ;
	if (RegQueryValueEx(hParamKey, PINO_REG_IO1BASE_STR,
			NULL, NULL,	(LPBYTE)&Io1BaseAddress, &ParamLength) != ERROR_SUCCESS) {
			Io1BaseAddress = PINO_REG_IO1BASE_VAL ;
			if(RegSetValueEx(hParamKey, PINO_REG_IO1BASE_STR, 0, REG_DWORD,
						(LPBYTE)&Io1BaseAddress, sizeof(DWORD)) != ERROR_SUCCESS) {
				return FALSE ;
			}
	}
	// IO2 Base Address
	ParamLength = sizeof(DWORD) ;
	if (RegQueryValueEx(hParamKey, PINO_REG_IO2BASE_STR,
			NULL, NULL,	(LPBYTE)&Io2BaseAddress, &ParamLength) != ERROR_SUCCESS) {
			Io2BaseAddress = PINO_REG_IO2BASE_VAL ;
			if(RegSetValueEx(hParamKey, PINO_REG_IO2BASE_STR, 0, REG_DWORD,
						(LPBYTE)&Io2BaseAddress, sizeof(DWORD)) != ERROR_SUCCESS) {
				return FALSE ;
			}
	}

	return(TRUE) ;
}
//************************************************************
//** hCõp[^WXg쐬					**
//**														**
//************************************************************
BOOL	SetRegistry(void)
{
	// hCõWXg쐬
	// J[h

	// Internal Base Mamory Address
	if(RegSetValueEx(hParamKey, PINO_REG_INTBASE_STR, 0, REG_DWORD,
				(LPBYTE)&IntBaseAddress, sizeof(DWORD)) != ERROR_SUCCESS) {
		return FALSE ;
	}
	// External Base Mamory Address
	if(RegSetValueEx(hParamKey, PINO_REG_EXTBASE_STR, 0, REG_DWORD,
				(LPBYTE)&ExtBaseAddress, sizeof(DWORD)) != ERROR_SUCCESS) {
		return FALSE ;
	}
	// IO1 Base Address
	if(RegSetValueEx(hParamKey, PINO_REG_IO1BASE_STR, 0, REG_DWORD,
				(LPBYTE)&Io1BaseAddress, sizeof(DWORD)) != ERROR_SUCCESS) {
		return FALSE ;
	}
	// IO2 Base Address
	if(RegSetValueEx(hParamKey, PINO_REG_IO2BASE_STR, 0, REG_DWORD,
				(LPBYTE)&Io2BaseAddress, sizeof(DWORD)) != ERROR_SUCCESS) {
		return FALSE ;
	}

	return(TRUE) ;
}
//************************************************************
//** _CAOlݒ									**
//**														**
//************************************************************
void	InitDialogCntl(HWND hDlg)
{
	char	Buffer[256] ;

	hwndInt = GetDlgItem(hDlg, IDC_INT_EDIT) ; 
	hwndExt = GetDlgItem(hDlg, IDC_EXT_EDIT) ; 
	hwndIo1 = GetDlgItem(hDlg, IDC_IO1_EDIT) ; 
	hwndIo2 = GetDlgItem(hDlg, IDC_IO2_EDIT) ; 

	if (hwndInt) {
		sprintf(Buffer, "%08X",IntBaseAddress) ;
		SetWindowText(hwndInt, Buffer) ;
	}
	if (hwndExt) {
		sprintf(Buffer, "%08X",ExtBaseAddress) ;
		SetWindowText(hwndExt, Buffer) ;
	}
	if (hwndIo1) {
		sprintf(Buffer, "%04X",Io1BaseAddress) ;
		SetWindowText(hwndIo1, Buffer) ;
	}
	if (hwndIo2) {
		sprintf(Buffer, "%04X",Io2BaseAddress) ;
		SetWindowText(hwndIo2, Buffer) ;
	}
}
//************************************************************
//** _CAOR}hvV[W							**
//**														**
//** _CAObZ[W								**
//************************************************************
BOOL APIENTRY RunDlgProc (HWND hDlg, UINT message, UINT wParam, LONG lParam)
{
	DWORD	OpenType ;

	switch(message) {
		case WM_INITDIALOG:
			// 
			if (RegCreateKeyEx(	HKEY_LOCAL_MACHINE, 
								PINO_REG_KEY, 
								0, 
								"PINOLITE",
								REG_OPTION_NON_VOLATILE,
								KEY_READ | KEY_WRITE, 
								NULL,
								&hParamKey,
								&OpenType) != ERROR_SUCCESS ||  !GetRegistry()) {
					MessageBox(hDlg, "Fail !!", "Error", MB_OK);
					EndDialog(hDlg, FALSE);
					return TRUE;
			}
			InitDialogCntl(hDlg) ;

			if (hwndInt) {
				wpOrigIntEditProc = (WNDPROC) SetWindowLong(hwndInt,
									GWL_WNDPROC, (LONG) EditSubclassProcMem);
			}
			if (hwndExt) {
				wpOrigExtEditProc = (WNDPROC) SetWindowLong(hwndExt,
								GWL_WNDPROC, (LONG) EditSubclassProcMem);
			}
			if (hwndIo1) {
				wpOrigIo1EditProc = (WNDPROC) SetWindowLong(hwndIo1,
								GWL_WNDPROC, (LONG) EditSubclassProcIo); 
			}
			if (hwndIo2) {
				wpOrigIo2EditProc = (WNDPROC) SetWindowLong(hwndIo2,
								GWL_WNDPROC, (LONG) EditSubclassProcIo); 
			}
			return(TRUE) ;

        case WM_DESTROY: 
 			if (hwndInt) {
				SetWindowLong(hwndInt, GWL_WNDPROC, (LONG) wpOrigIntEditProc);
			}
 			if (hwndExt) {
				SetWindowLong(hwndExt, GWL_WNDPROC, (LONG) wpOrigExtEditProc); 
			}
 			if (hwndIo1) {
				SetWindowLong(hwndIo1, GWL_WNDPROC, (LONG) wpOrigIo1EditProc); 
			}
 			if (hwndIo2) {
				SetWindowLong(hwndIo2, GWL_WNDPROC, (LONG) wpOrigIo2EditProc);
			}
			break; 

		case WM_CLOSE:
			// I
			EndDialog(hDlg, TRUE);
			return(TRUE) ;

		case WM_COMMAND:
			// Rg[̗v
			switch(LOWORD(wParam)) {
				case IDOK:
					// I
					SetRegistry() ;
					EndDialog(hDlg, TRUE);
					return(TRUE) ;
				case IDCANCEL:
					// I
					EndDialog(hDlg, TRUE);
					return(TRUE) ;
			}
			break ;
		default:
			break;
	}
    return (FALSE);
}
LRESULT APIENTRY EditSubclassProcMem(HWND hwnd, UINT uMsg, WPARAM wParam, LPARAM lParam) 
{ 
	char	Buffer[256], *stopstrings ;
	DWORD	Val ;

	switch(uMsg) {
		case WM_CHAR:
			wParam = toupper(wParam) ;
			if (!isdigit(wParam)
				&& (wParam < 'A' || wParam > 'F')
				&& !iscntrl(wParam)) {
				return(TRUE) ;
			}
			break ;
		case WM_KILLFOCUS:
			GetWindowText(hwnd, Buffer, 9) ;
			Val = strtoul( Buffer, &stopstrings, 16) ;
			Val &= 0xff000000 ;
			sprintf(Buffer, "%08X",Val) ;
			SetWindowText(hwnd, Buffer) ;
			if (hwnd == hwndInt) {
				IntBaseAddress = Val ;
			}
			else {
				ExtBaseAddress = Val ;
			}
			break ;
		default:
			break;
	}
    if (hwndInt == hwnd) { 
		return(CallWindowProc(wpOrigIntEditProc, hwnd, uMsg, wParam, lParam)) ;
	}
	return(CallWindowProc(wpOrigExtEditProc, hwnd, uMsg, wParam, lParam)) ;
} 
LRESULT APIENTRY EditSubclassProcIo(HWND hwnd, UINT uMsg, WPARAM wParam, LPARAM lParam) 
{ 
	char	Buffer[256], *stopstrings ;
	DWORD	Val ;

	switch(uMsg) {
		case WM_CHAR:
			wParam = toupper(wParam) ;
			if (!isdigit(wParam)
				&& (wParam < 'A' || wParam > 'F')
				&& !iscntrl(wParam)) {
				return(TRUE) ;
			}
			break ;
		case WM_KILLFOCUS:
			GetWindowText(hwnd, Buffer, 9) ;
			Val = strtoul( Buffer, &stopstrings, 16) ;
			Val &= 0x0000ff00 ;
			sprintf(Buffer, "%04X",Val) ;
			SetWindowText(hwnd, Buffer) ;
			if (hwnd == hwndIo1) {
				Io1BaseAddress = Val ;
			}
			else {
				Io2BaseAddress = Val ;
			}
			break ;
		default:
			break;
	}
    if (hwnd == hwndIo1) { 
		return(CallWindowProc(wpOrigIo1EditProc, hwnd, uMsg, wParam, lParam)) ;
	}
	return(CallWindowProc(wpOrigIo2EditProc, hwnd, uMsg, wParam, lParam)) ;
} 


