#define __PINOLITEDLL_MAKE 1
#include "..\include\PinoLCtl.h"
#include "..\include\PinoLdll.h"
#include "PinoLDev.h"
#include	<conio.h>

#ifdef __PINODEBUG
	#define	DEBUG_INTMEM_SIZE   1000
	#define	DEBUG_EXTMEM_SIZE   1000

    BYTE    DebExtMemory[1000] ;
    BYTE    DebIntMemory[1000] ;
    BYTE    DebIOS1[256] ;
    BYTE    DebIOS2[256] ;

#endif

#define PINO_REG_KEY			"System\\CurrentControlSet\\Services\\Class\\PinoLite"
#define	PINO_REG_INTBASE_STR	"IntMemBaseAddress"
#define	PINO_REG_EXTBASE_STR	"ExtMemBaseAddress"
#define	PINO_REG_IO1BASE_STR	"Io1BaseAddress"
#define	PINO_REG_IO2BASE_STR	"Io2BaseAddress"

PinoDevice::PinoDevice(void)
{
    DeviceOK = FALSE ;
    Vhdl = CreateFile( "\\\\.\\PinoLite.vxd",0, 0, NULL, 0, 0, NULL ) ;
}
PinoDevice::~PinoDevice(void)
{
    if ( Vhdl == INVALID_HANDLE_VALUE ) return ;
    CloseHandle( Vhdl ) ;
}
BOOL   PinoDevice::Init(void)
{
    if ( Vhdl == INVALID_HANDLE_VALUE ) return(FALSE) ;
	DWORD   Dt ;
    DWORD   lng ;

	if (DeviceIoControl( Vhdl, _GETDEVICEID, NULL, 0, &Dt, sizeof(DWORD), &lng, NULL)) {
	    DeviceID = Dt ;
	} else return(FALSE) ;
	if (DeviceIoControl( Vhdl, _GETVENDORID, NULL, 0, &Dt, sizeof(DWORD), &lng, NULL)) {
	    VendorID = Dt ;
	} else return(FALSE) ;
	if (DeviceIoControl( Vhdl, _GETVERSION, NULL, 0, &Dt, sizeof(DWORD), &lng, NULL)) {
	    Version = Dt ;
	} else return(FALSE) ;

#ifndef __PINODEBUG

    if(VendorID != 0x10cf || DeviceID != 0x2004)  return(FALSE) ;

	HKEY	hParamKey ;
	DWORD	ParamLength = sizeof(DWORD) ;
	if (RegOpenKey(HKEY_LOCAL_MACHINE, PINO_REG_KEY, &hParamKey) == ERROR_SUCCESS) {
		// Internal Base Mamory Address
		ParamLength = sizeof(DWORD) ;
		if (RegQueryValueEx(hParamKey, PINO_REG_INTBASE_STR,
				NULL, NULL,	(LPBYTE)&IntAddress, &ParamLength) != ERROR_SUCCESS) {
			IntAddress = 0 ;
		}

		// External Base Mamory Address
		ParamLength = sizeof(DWORD) ;
		if (RegQueryValueEx(hParamKey, PINO_REG_EXTBASE_STR,
				NULL, NULL,	(LPBYTE)&ExtAddress, &ParamLength) != ERROR_SUCCESS) {
			ExtAddress = 0 ;
		}
	
		// IO1 Base Address
		ParamLength = sizeof(DWORD) ;
		if (RegQueryValueEx(hParamKey, PINO_REG_IO1BASE_STR,
				NULL, NULL,	(LPBYTE)&IO1Address, &ParamLength) != ERROR_SUCCESS) {
			IO1Address = 0 ;
		}
	
		// IO2 Base Address
		ParamLength = sizeof(DWORD) ;
		if (RegQueryValueEx(hParamKey, PINO_REG_IO2BASE_STR,
				NULL, NULL,	(LPBYTE)&IO2Address, &ParamLength) != ERROR_SUCCESS) {
			IO2Address = 0 ;
		}
		RegCloseKey(hParamKey) ;
	}
	else {
		IntAddress = 0 ;
		ExtAddress = 0 ;
		IO1Address = 0 ;
		IO2Address = 0 ;
	}

    for (DWORD Dev_Num = 0; Dev_Num < 32; Dev_Num++) {
        for (DWORD Bus_Num = 0; Bus_Num < 256; Bus_Num++) {
            if (PCI_Search(0x200410cf, Dev_Num, Bus_Num, 1) == TRUE) {
                    DWORD Reg = (Dev_Num << 11) + (Bus_Num << 16) + 0x80000100 ; // Func 1

					_outpd( 0xcf8, Reg + 0x4) ;
					_outpd( 0xcfc, 0x3 ) ;

					_outpd( 0xcf8, Reg + 0x10) ;
					if (ExtAddress == 0)	ExtAddress = _inpd( 0xcfc ) ;
					else					_outpd( 0xcfc, ExtAddress ) ;
					_outpd( 0xcf8, Reg + 0x14) ;
 					if (IntAddress == 0)	IntAddress = _inpd( 0xcfc ) ;
					else					_outpd( 0xcfc, IntAddress ) ;
					_outpd( 0xcf8, Reg + 0x18) ;
 					if (IO1Address == 0)	IO1Address = _inpd( 0xcfc ) ;
					else					_outpd( 0xcfc, IO1Address ) ;
   					_outpd( 0xcf8, Reg + 0x1c) ;
 					if (IO2Address == 0)	IO2Address = _inpd( 0xcfc ) ;
					else					_outpd( 0xcfc, IO2Address ) ;

					PINOBASECFG	PinoCfg ;

					PinoCfg.Int_MemoryBase = IntAddress ;
					PinoCfg.Ext_MemoryBase = ExtAddress ;
					PinoCfg.IO0_Base = IO1Address ;
					PinoCfg.IO1_Base = IO2Address ;
					if (DeviceIoControl( Vhdl, _SETPINOBASEADDRESS,
							&PinoCfg, sizeof(PINOBASECFG), NULL, 0, &lng, NULL)) {
						IntLinearAddress = Dt ;
					} else return(FALSE) ;

					if (DeviceIoControl( Vhdl, _GETPINOINTLINADDRESS,
							NULL, 0, &Dt, sizeof(DWORD), &lng, NULL)) {
						IntLinearAddress = Dt ;
					} else return(FALSE) ;
					if (DeviceIoControl( Vhdl, _GETPINOEXTLINADDRESS,
							NULL, 0, &Dt, sizeof(DWORD), &lng, NULL)) {
						ExtLinearAddress = Dt ;
					} else return(FALSE) ;

					DeviceOK = TRUE ;
					_outpd((unsigned short)(IO1Address + 0xc4), 0x0000000e) ;
					_outpd((unsigned short)(IO2Address + 0x00), 0xed32ebc8) ;
					_outpd((unsigned short)(IO2Address + 0x10), 0x00018000) ;
 					return(TRUE) ;
          }
        }
    }

#endif

    return(FALSE) ;
}
BOOL   PinoDevice::PCI_Search(DWORD VenDev, DWORD Dn, DWORD Bn, DWORD Fn)
{
	DWORD	Dev_Num = Dn ;
	DWORD   Bus_Num = Bn ;
	DWORD	Fnc_Num = Fn ;
	DWORD	Dat ;

    Dev_Num <<= 11 ;
    Bus_Num <<= 16 ;
	Fnc_Num <<= 8 ;
	Dev_Num += 0x80000000 ;

    _outpd(0xcf8, Dev_Num + Bus_Num + Fnc_Num) ;
    Dat = _inpd( 0xcfc ) ;
	if (Dat == VenDev)  return(TRUE) ;
	else                return(FALSE) ;
}

DWORD   PinoDevice::GetPCIConfig(void)
{
    if (DeviceOK != TRUE)	return(NULL) ;

    DWORD   lng ;
    DWORD   Dt ;
    DeviceIoControl( Vhdl,
                     _GETPINOPCICONFIG,
                     NULL,
                     0,
                     &Dt,
                     sizeof(PCICONFIG),
                     &lng,
                     NULL );
    return(Dt) ;
}
BOOL    PinoDevice::LogicalMemoryRead(DWORD Addr, VOID *pBlock, DWORD count, WORD type)
{
    if (Addr >= INTADDRESSTOP && Addr <= INTADDRESSEND) {
        // Internal Address Memory
        if (MemoryRead(Addr, pBlock, count, type) != TRUE) return(FALSE) ;
    }
    else if (Addr >= EXTADDRESSTOP && Addr <= EXTADDRESSEND) {
        // External Address Memory
        if (MemoryRead(Addr, pBlock, count, type) != TRUE) return(FALSE) ;
    }
    else if (Addr >= IO1ADDRESSTOP && Addr <= IO1ADDRESSEND) {
        // IOS1 Address Memory
        if (MemoryRead(Addr, pBlock, count, type) != TRUE) return(FALSE) ;
    }
    else if (Addr >= IO2ADDRESSTOP && Addr <= IO2ADDRESSEND) {
        // IOS2 Address Memory
        if (MemoryRead(Addr, pBlock, count, type) != TRUE) return(FALSE) ;
    }
    else {
        return(FALSE) ;
    }
    return(TRUE) ;
}
BOOL    PinoDevice::LogicalMemoryWrite(DWORD Addr, VOID *pBlock, DWORD count, WORD type)
{
    if (Addr >= INTADDRESSTOP && Addr <= INTADDRESSEND) {
        // Internal Address Memory
        if (MemoryWrite(Addr, pBlock, count, type) != TRUE) return(FALSE) ;
    }
    else if (Addr >= EXTADDRESSTOP && Addr <= EXTADDRESSEND) {
        // External Address Memory
        if (MemoryWrite(Addr, pBlock, count, type) != TRUE) return(FALSE) ;
    }
    else if (Addr >= IO1ADDRESSTOP && Addr <= IO1ADDRESSEND) {
        // IOS1 Address Memory
        if (MemoryWrite(Addr, pBlock, count, type) != TRUE) return(FALSE) ;
    }
    else if (Addr >= IO2ADDRESSTOP && Addr <= IO2ADDRESSEND) {
        // IOS2 Address Memory
        if (MemoryWrite(Addr, pBlock, count, type) != TRUE) return(FALSE) ;
    }
    else {
        return(FALSE) ;
    }
    return(TRUE) ;
}
DWORD   PinoDevice::GetAvalavleMemoryAddress(DWORD Addr)
{
    DWORD   AvlAddr = 0xffffffff ;

#ifndef __PINODEBUG
    if (Addr >= INTADDR0TOP && Addr <= INTADDR0END) {
        AvlAddr = ((Addr - INTADDRESSTOP) + IntLinearAddress) ;
    }
    if (Addr >= INTADDR1TOP && Addr <= INTADDR1END) {
        AvlAddr = ((Addr - INTADDRESSTOP) + IntLinearAddress) ;
    }
    if (Addr >= INTADDR2TOP && Addr <= INTADDR2END) {
        AvlAddr = ((Addr - INTADDRESSTOP) + IntLinearAddress) ;
    }
    if (Addr >= EXTADDRESSTOP && Addr <= EXTADDRESSEND) {
        AvlAddr = ((Addr - EXTADDRESSTOP) + ExtLinearAddress) ;
        DummyWait() ;
    }
#else
    if (Addr >= INTADDR0TOP && Addr <= INTADDR0END) {
        AvlAddr = (DWORD)DebIntMemory ;
        if ((Addr - INTADDRESSTOP) < DEBUG_INTMEM_SIZE) {
            AvlAddr = ((Addr - INTADDRESSTOP) + (DWORD)DebIntMemory) ;
        }
    }
    if (Addr >= INTADDR1TOP && Addr <= INTADDR1END) {
        AvlAddr = (DWORD)DebIntMemory ;
        if ((Addr - INTADDRESSTOP) < DEBUG_INTMEM_SIZE) {
            AvlAddr = ((Addr - INTADDRESSTOP) + (DWORD)DebIntMemory) ;
        }
    }
    if (Addr >= INTADDR2TOP && Addr <= INTADDR2END) {
        AvlAddr = (DWORD)DebIntMemory ;
        if ((Addr - INTADDRESSTOP) < DEBUG_INTMEM_SIZE) {
            AvlAddr = ((Addr - INTADDRESSTOP) + (DWORD)DebIntMemory) ;
        }
    }
    if (Addr >= EXTADDRESSTOP && Addr <= EXTADDRESSEND) {
        AvlAddr = (DWORD)DebExtMemory ;
        if ((Addr - EXTADDRESSTOP) < DEBUG_EXTMEM_SIZE) {
            AvlAddr = ((Addr - EXTADDRESSTOP) + (DWORD)DebExtMemory) ;
        }
    }
#endif
    return(AvlAddr) ;
}
DWORD   PinoDevice::GetAvalavleIOAddress(DWORD Addr)
{
    DWORD   AvlAddr = 0xffffffff ;

#ifndef __PINODEBUG
    if (Addr >= IO1_MIDMATOP && Addr <= IO1_MIDMAEND) {
        AvlAddr = (Addr - IO1_MIDMATOP) + RIO1_MIDMA + IO1Address ;
    }
    else if (Addr >= IO1_MODMATOP && Addr <= IO1_MODMAEND) {
        AvlAddr = (Addr - IO1_MODMATOP) + RIO1_MODMA + IO1Address ;
    }
    else if (Addr >= IO1_IOCNFTOP && Addr <= IO1_IOCNFEND) {
        AvlAddr = (Addr - IO1_IOCNFTOP) + RIO1_IOCNF + IO1Address ;
    }
    else if (Addr >= IO1_CORETOP && Addr <= IO1_COREEND) {
        AvlAddr = (Addr - IO1_CORETOP) + RIO1_CORE + IO1Address ;
    }
    else if (Addr >= IO2_EXTRAMTOP && Addr <= IO2_EXTRAMEND) {
        AvlAddr = (Addr - IO2_EXTRAMTOP) + RIO2_EXTRAM + IO2Address ;
    }
    else if (Addr >= IO2_PCITOP && Addr <= IO2_PCIEND) {
        AvlAddr = (Addr - IO2_PCITOP) + RIO2_PCI + IO2Address ;
    }
    else if (Addr >= IO2_MSTTOP && Addr <= IO2_MSTEND) {
        AvlAddr = (Addr - IO2_MSTTOP) + RIO2_MST + IO2Address ;
    }
#else

    if (Addr >= IO1_MIDMATOP && Addr <= IO1_MIDMAEND) {
        AvlAddr = (Addr - IO1_MIDMATOP) + RIO1_MIDMA + (DWORD)DebIOS1 ;
    }
    else if (Addr >= IO1_MODMATOP && Addr <= IO1_MODMAEND) {
        AvlAddr = (Addr - IO1_MODMATOP) + RIO1_MODMA + (DWORD)DebIOS1 ;
    }
    else if (Addr >= IO1_IOCNFTOP && Addr <= IO1_IOCNFEND) {
        AvlAddr = (Addr - IO1_IOCNFTOP) + RIO1_IOCNF + (DWORD)DebIOS1 ;
    }
    else if (Addr >= IO1_CORETOP && Addr <= IO1_COREEND) {
        AvlAddr = (Addr - IO1_CORETOP) + RIO1_CORE + (DWORD)DebIOS1 ;
    }
    else if (Addr >= IO2_EXTRAMTOP && Addr <= IO2_EXTRAMEND) {
        AvlAddr = (Addr - IO2_EXTRAMTOP) + RIO2_EXTRAM + (DWORD)DebIOS2 ;
    }
    else if (Addr >= IO2_PCITOP && Addr <= IO2_PCIEND) {
        AvlAddr = (Addr - IO2_PCITOP) + RIO2_PCI + (DWORD)DebIOS2 ;
    }
    else if (Addr >= IO2_MSTTOP && Addr <= IO2_MSTEND) {
        AvlAddr = (Addr - IO2_MSTTOP) + RIO2_MST + (DWORD)DebIOS2 ;
    }

#endif
    return(AvlAddr) ;
}
BOOL    PinoDevice::MemoryWrite(DWORD Addr, VOID *pBlock, DWORD count, WORD type)
{
    if (type == sizeof(BYTE)) {
        DWORD  *LinAddr ;
        BYTE   *Dst ;
        Dst = (BYTE *)pBlock ;
        for (DWORD i = 0; i < count; i++) {
            if (Addr > EXTADDRESSEND) return(-1) ;
            LinAddr = (DWORD *)GetAvalavleMemoryAddress(Addr & 0xfffffffc) ;
            if (LinAddr != (DWORD *)0xffffffff) {
                DWORD   PinoDat = *LinAddr ;
                if      ((Addr & 0x00000003) == 0) {
                    PinoDat = ((PinoDat & 0xffffff00) | (((DWORD)*Dst) & 0x000000ff)) ;
                }
                else if ((Addr & 0x00000003) == 1) {
                    PinoDat = ((PinoDat & 0xffff00ff) | ((((DWORD)*Dst) << 8 )& 0x0000ff00)) ;
                }
                else if ((Addr & 0x00000003) == 2) {
                    PinoDat = ((PinoDat & 0xff00ffff) | ((((DWORD)*Dst) << 16 )& 0x00ff0000)) ;
                }
                else {
                    PinoDat = ((PinoDat & 0x00ffffff) | ((((DWORD)*Dst) << 24 )& 0xff000000)) ;
                }
                // Dummy Wait!!
                DummyWait() ;
                *LinAddr = PinoDat ;
            }
            else {
                DWORD   IOAddr = GetAvalavleIOAddress(Addr) ;
                if (IOAddr != 0xffffffff) {
                    #ifndef __PINODEBUG
                        _outp((WORD)IOAddr, *Dst) ;
                    #else
                        *((BYTE *)IOAddr) = *Dst ;
                    #endif
                }
            }
            Dst++ ;
            Addr += type ;
        }
    }
    else if (type == sizeof(WORD)) {
        DWORD  *LinAddr ;
        WORD   *Dst ;
        Dst = (WORD *)pBlock ;
        for (DWORD i = 0; i < count; i++) {
            if (Addr > EXTADDRESSEND) return(-1) ;
            LinAddr = (DWORD *)GetAvalavleMemoryAddress(Addr & 0xfffffffc) ;
            if (LinAddr != (DWORD *)0xffffffff) {
                DWORD   PinoDat = *LinAddr ;
                if      ((Addr & 0x00000002) == 0) {
                    PinoDat = ((PinoDat & 0xffff0000) | (((DWORD)*Dst) & 0x0000ffff)) ;
                }
                else {
                    PinoDat = ((PinoDat & 0x0000ffff) | ((((DWORD)*Dst) << 16 )& 0xffff0000)) ;
                }
                // Dummy Wait!!
                DummyWait() ;
                *LinAddr = PinoDat ;
            }
            else {
                DWORD   IOAddr = GetAvalavleIOAddress(Addr) ;
                if (IOAddr != 0xffffffff) {
                    #ifndef __PINODEBUG
                        _outpw((WORD)IOAddr, *Dst) ;
                    #else
                        *((WORD *)IOAddr) = *Dst ;
                    #endif
                }
            }
            Dst++ ;
            Addr += type ;
        }
    }
    else if (type == sizeof(DWORD)) {
        DWORD  *LinAddr ;
        DWORD  *Dst ;
        Dst = (DWORD *)pBlock ;
        for (DWORD i = 0; i < count; i++) {
            if (Addr > EXTADDRESSEND) return(-1) ;
            LinAddr = (DWORD *)GetAvalavleMemoryAddress(Addr & 0xfffffffc) ;
            if (LinAddr != (DWORD *)0xffffffff) {
                // Dummy Wait!!
                DummyWait() ;
                *LinAddr = *Dst ;
            }
            else {
                DWORD   IOAddr = GetAvalavleIOAddress(Addr) ;
                if (IOAddr != 0xffffffff) {
                    #ifndef __PINODEBUG
                        _outpd((WORD)IOAddr, *Dst) ;
                    #else
                        *((DWORD *)IOAddr) = *Dst ;
                    #endif
                }
            }
            Dst++ ;
            Addr += type ;
        }
    }
    else {
        return(FALSE) ;
    }

    return(TRUE) ;
}
BOOL    PinoDevice::MemoryRead(DWORD Addr, VOID *pBlock, DWORD count, WORD type)
{
    if (type == sizeof(BYTE)) {
        BYTE  *LinAddr ;
        BYTE  *Dst ;
        Dst = (BYTE *)pBlock ;
        for (DWORD i = 0; i < count; i++) {
            if (Addr > EXTADDRESSEND) return(-1) ;
            LinAddr = (BYTE *)GetAvalavleMemoryAddress(Addr) ;
            if (LinAddr != (BYTE *)0xffffffff) {
                *Dst = *LinAddr ;
            }
            else {
                DWORD IOAddr = GetAvalavleIOAddress(Addr) ;
                if (IOAddr != 0xffffffff) {
                    #ifndef __PINODEBUG
                        *Dst = _inp((WORD)IOAddr) ;
                    #else
                        *Dst = *((BYTE *)IOAddr) ;
                    #endif
                }
                else {
                    *Dst = 0xff ;
                }
            }
            Dst++ ;
            Addr += type ;
        }
    }
    else if (type == sizeof(WORD)) {
        WORD  *LinAddr ;
        WORD  *Dst ;
        Dst = (WORD *)pBlock ;
        for (DWORD i = 0; i < count; i++) {
            if (Addr > EXTADDRESSEND) return(-1) ;
            LinAddr = (WORD *)GetAvalavleMemoryAddress(Addr) ;
            if (LinAddr != (WORD *)0xffffffff) {
                *Dst = *LinAddr ;
            }
            else {
                DWORD IOAddr = GetAvalavleIOAddress(Addr) ;
                if (IOAddr != 0xffffffff) {
                    #ifndef __PINODEBUG
                        *Dst = _inpw((WORD)IOAddr) ;
                    #else
                        *Dst = *((WORD *)IOAddr) ;
                    #endif
                }
                else {
                    *Dst = 0xffff ;
                }
            }
            Dst++ ;
            Addr += type ;
        }
    }
    else if (type == sizeof(DWORD)) {
        DWORD  *LinAddr ;
        DWORD  *Dst ;
        Dst = (DWORD *)pBlock ;
        for (DWORD i = 0; i < count; i++) {
            if (Addr > EXTADDRESSEND) return(-1) ;
            LinAddr = (DWORD *)GetAvalavleMemoryAddress(Addr) ;
            if (LinAddr != (DWORD *)0xffffffff) {
                *Dst = *LinAddr ;
            }
            else {
                DWORD IOAddr = GetAvalavleIOAddress(Addr) ;
                if (IOAddr != 0xffffffff) {
                    #ifndef __PINODEBUG
                        *Dst = _inpd((WORD)IOAddr) ;
                    #else
                        *Dst = *((DWORD *)IOAddr) ;
                    #endif
                }
                else {
                    *Dst = 0xffffffff ;
                }
            }
            Dst++ ;
            Addr += type ;
        }
    }
    else {
        return(FALSE) ;
    }

    return(TRUE) ;
}
void	PinoDevice::DummyWait(void)
{
    for(int i = 0; i < 50; i++) {
        _inp((WORD)IO1Address) ;
    }
}
