#define __PINOLITEDLL_MAKE 1
#include "..\include\PinoLdll.h"
#include "PinoLDev.h"

static	PinoDevice	*PDev = NULL ;


BOOL DllExport cPinoOpen(void)
{
    if (PDev != NULL) {
        return(TRUE) ;
    }
    PDev = new PinoDevice() ;
    if (PDev == NULL)   return(FALSE) ;
    if (PDev->Init() == FALSE) {
        delete PDev ;
        PDev = NULL ;
        return(FALSE) ;
    }
    return(TRUE) ;
}
BOOL DllExport cPinoClose(void)
{
    if (PDev == NULL)   return(FALSE) ;
    delete PDev ;
    PDev = NULL ;
    return(TRUE) ;
}
BOOL    DllExport cPinoDeviceInfo(PINOLITEDEVICEINFO *Info)
{
    if (PDev == NULL) {
        return(FALSE) ;
    }
    Info->DriverVersion = PDev->GetVersion() ;
    Info->VendorID = PDev->GetVendorID() ;
    Info->DeviceID = PDev->GetDeviceID() ;
    Info->PinoIntAddress = PDev->GetIntAddress() ;
    Info->PinoExtAddress = PDev->GetExtAddress() ;
    Info->PinoIO1Address = PDev->GetIO1Address() ;
    Info->PinoIO2Address = PDev->GetIO2Address() ;

    return(TRUE) ;
}
DWORD   DllExport cPinoPciConfig(void)
{
    if (PDev == NULL) {
        return(FALSE) ;
    }

    return(PDev->GetPCIConfig()) ;
}
BOOL    DllExport cPinoReadBlockByte(ULONG Addr, BYTE *pBlock, long count)
{
    if (PDev == NULL) {
        return(FALSE) ;
    }

    return(PDev->LogicalMemoryRead((DWORD)Addr, pBlock, (DWORD)count, sizeof(BYTE))) ;
}
BOOL    DllExport cPinoReadBlockShort(ULONG Addr, short *pBlock, long count)
{
    if (PDev == NULL) {
        return(FALSE) ;
    }

    return(PDev->LogicalMemoryRead((DWORD)Addr, pBlock, (DWORD)count, sizeof(WORD))) ;
}
BOOL    DllExport cPinoReadBlockLong(ULONG Addr, long *pBlock, long count)
{
    if (PDev == NULL) {
        return(FALSE) ;
    }

    return(PDev->LogicalMemoryRead((DWORD)Addr, pBlock, (DWORD)count, sizeof(DWORD))) ;
}
BOOL    DllExport cPinoWriteBlockByte(ULONG Addr, BYTE *pBlock, long count)
{
    if (PDev == NULL) {
        return(FALSE) ;
    }

    return(PDev->LogicalMemoryWrite((DWORD)Addr, pBlock, (DWORD)count, sizeof(BYTE))) ;
}
BOOL    DllExport cPinoWriteBlockShort(ULONG Addr, short *pBlock, long count)
{
    if (PDev == NULL) {
        return(FALSE) ;
    }

    return(PDev->LogicalMemoryWrite((DWORD)Addr, pBlock, (DWORD)count, sizeof(WORD))) ;
}
BOOL    DllExport cPinoWriteBlockLong(ULONG Addr, long *pBlock, long count)
{
    if (PDev == NULL) {
        return(FALSE) ;
    }

    return(PDev->LogicalMemoryWrite((DWORD)Addr, pBlock, (DWORD)count, sizeof(DWORD))) ;
}
BOOL    DllExport cPinoBuffAlloc(ULONG Size, ULONG *pAddr, long *pHNO)
{
    if (PDev == NULL) {
        return(FALSE) ;
    }


    return(TRUE) ;
}
BOOL    DllExport cPinoBuffFree(long HNO)
{
    if (PDev == NULL) {
        return(FALSE) ;
    }


    return(TRUE) ;
}
BOOL    DllExport cPinoReadBuffByte(long HNO, ULONG Offs, BYTE *pBlock, long count)
{
    if (PDev == NULL) {
        return(FALSE) ;
    }


    return(TRUE) ;
}
BOOL    DllExport cPinoReadBuffShort(long HNO, ULONG Offs, short  *pBlock, long count)
{
    if (PDev == NULL) {
        return(FALSE) ;
    }


    return(TRUE) ;
}
BOOL    DllExport cPinoReadBuffLong(long HNO, ULONG Offs, long *pBlock, long count)
{
    if (PDev == NULL) {
        return(FALSE) ;
    }


    return(TRUE) ;
}
BOOL    DllExport cPinoWriteBuffByte(long HNO, ULONG Offs, BYTE *pBlock, long count)
{
    if (PDev == NULL) {
        return(FALSE) ;
    }


    return(TRUE) ;
}
BOOL    DllExport cPinoWriteBuffShort(long HNO, ULONG Offs, short  *pBlock, long count)
{
    if (PDev == NULL) {
        return(FALSE) ;
    }


    return(TRUE) ;
}
BOOL    DllExport cPinoWriteBuffLong(long HNO, ULONG Offs, long *pBlock, long count)
{
    if (PDev == NULL) {
        return(FALSE) ;
    }


    return(TRUE) ;
}
long    DllExport cPinoGetINTA(void)
{
    if (PDev == NULL) {
        return(-1) ;
    }


    return(0L) ;
}
