#ifndef __SRVNUM_H__
#define __SRVNUM_H__

#ifdef __PINOLITEDLL_MAKE
#include	<windows.h>
#endif
/****************************************************************************
*  Virtual Driver For Windows 95                                            *
*  DeviceIoControl                                                          *
*  Copyright (C) 1996  Orange Wine Inc. All Rights Reserved.                *
****************************************************************************/
// PinoLite PCI Configration struct
// Service Number
#define _GETVERSION             1       // Get Device Driver Version
#define _GETVENDORID            2       // Get Vendor ID
#define _GETDEVICEID            3       // Get Device ID
#define _GETPINOINTADDRESS      4       // Get Pino Interanl Address
#define _GETPINOEXTADDRESS      5       // Get Pino External Address
#define _GETPINOINTLINADDRESS   6       // Get Pino Interanl Address
#define _GETPINOEXTLINADDRESS   7       // Get Pino External Address
#define _GETPINOIO1ADDRESS      8       // Get Pino IO Space 1 Address
#define _GETPINOIO2ADDRESS      9       // Get Pino IO Space 21 Address
#define _LINEARTOPHY           10       // Linear -> Physical Address
#define _PHYTOLINEAR           11       // Physical -> Linear Address
#define _ALLOCPYHISICAL        12       // Alloc Physical Memory Page
#define _ALLOCLINEAR           13       // Alloc Linear Memory Page
#define _FREELINEAR            14       // Free Linear Memory Page
#define _GETPINOPCICONFIG      15       // Get Pino PCI Config 0 Config
#define _SETPINOBASEADDRESS    16       // Set Pino Base Address


#define INTADDRESSTOP   0x00000000
#define INTADDRESSEND   0x0000ffff
#define EXTADDRESSTOP   0x08000000
#define EXTADDRESSEND   0x08ffffff
#define IO1ADDRESSTOP   0x00010000
#define IO1ADDRESSEND   0x000101ff
#define IO2ADDRESSTOP   0x00010200
#define IO2ADDRESSEND   0x000103ff

#define INTADDR0TOP     0x00000000
#define INTADDR0END     0x000000ff
#define INTADDR1TOP     0x00008000
#define INTADDR1END     0x000080ff
#define INTADDR2TOP     0x0000c000
#define INTADDR2END     0x0000c0ff

#define IO1_MIDMATOP    0x00010000
#define IO1_MIDMAEND    0x0001003f
#define IO1_MODMATOP    0x00010080
#define IO1_MODMAEND    0x000100bf
#define IO1_IOCNFTOP    0x00010100
#define IO1_IOCNFEND    0x0001013f
#define IO1_CORETOP     0x00010180
#define IO1_COREEND     0x000101bf

#define IO2_EXTRAMTOP   0x00010200
#define IO2_EXTRAMEND   0x0001023f
#define IO2_PCITOP      0x00010300
#define IO2_PCIEND      0x0001033f
#define IO2_MSTTOP      0x00010380
#define IO2_MSTEND      0x000103bf

#define RIO1_MIDMA      0x00
#define RIO1_MODMA      0x40
#define RIO1_IOCNF      0x80
#define RIO1_CORE       0xc0

#define RIO2_EXTRAM     0x00
#define RIO2_PCI        0x80
#define RIO2_MST        0xc0

//-----------------------------------------------------------
//-	PhyToLin	(DWORD ACCSESS)								-
//-----------------------------------------------------------
// Input
typedef struct t_PHY_BMEM_ACCESS {
    void *phyAddr;          // Phisical Address
    DWORD cnt ;             // data count (BYTE count)
    BYTE *data ;
} PHY_BMEM_ACCESS;

typedef struct t_PHY_WMEM_ACCESS {
    void *phyAddr;          // Phisical Address
    DWORD cnt ;             // data count (WORD count)
    WORD *data ;
} PHY_WMEM_ACCESS;

typedef struct t_PHY_DMEM_ACCESS {
    void *phyAddr;          // Phisical Address
    DWORD cnt ;             // data count (DWORD count)
    DWORD *data ;
} PHY_DMEM_ACCESS;

//-----------------------------------------------------------
//-	PhyToLin		    									-
//-----------------------------------------------------------
// Input
typedef struct t_PHY_TO_LIN {
    void *phyAddr;          // AhX
    ULONG size;             // TCY
} PHY_TO_LIN_CMD;

//-----------------------------------------------------------
//-	PageAlloc											    -
//-----------------------------------------------------------
// Output
typedef struct t_PAGE_ALLOC {
    void *linAddr;			// obt@jAAhX
    void *phyAddr;			// obt@AhX
} PAGE_ALLOC_OUT;

//-----------------------------------------------------------
//-	For PCI Function 1 BaseAddress						    -
//-----------------------------------------------------------
// Output
typedef struct t_PINOBASECFG {
	DWORD	Int_MemoryBase ;
	DWORD	Ext_MemoryBase ;
	DWORD	IO0_Base ;
	DWORD	IO1_Base ;
} PINOBASECFG;






#endif
