/****************************************************************************/
/* vxdcore.c                                                                */
/*      VxD Driver For Win95                                                */
/*                                                                          */
/* Copyright 1996  Orange Wine Inc.  All Rights Reserved.                   */
/****************************************************************************/
#include "pch.h"
#include <vwin32.h>
#include <winerror.h>
#include <vmm.h>

#pragma CM_PAGEABLE_DATA
#pragma CM_PAGEABLE_CODE

extern CONFIGRET OnConfigure( CONFIGFUNC cf, SUBCONFIGFUNC scf,
						DEVNODE devnode, DWORD refdata, ULONG flags);

/****************************************************************************
 *  OnSysDynamicDeviceInit
 *                 This procedure gets called the first time the DLVxD
 *                   is loaded (SYS_DYNAMIC_DEVICE_INIT)
 *
 *  Exported.
 *
 *  ENTRY:  DevInf is a pointer to the VXDLDR device info packet.
 *
 *  EXIT:   VXD_SUCCESS or VXD_FAILURE.
 *
 ***************************************************************************/
CM_VXD_RESULT CM_SYSCTRL OnSysDynamicDeviceInit(VOID)
{
    return(VXD_SUCCESS);
}

/****************************************************************************
 *  OnSysDynamicDeviceExit
 *                 This procedure gets called when the DLVxD is unloading
 *                  (SYS_DYNAMIC_DEVICE_EXIT)
 *
 *  Exported.
 *
 *  ENTRY:  DevInf is a pointer to the VXDLDR device info packet.
 *
 *      DDB is a pointer to the DDB that was created for this device.
 *
 *  EXIT:   VXD_SUCCESS or VXD_FAILURE.
 *
 ***************************************************************************/
CM_VXD_RESULT CM_SYSCTRL OnSysDynamicDeviceExit(VOID)
{
    return(VXD_SUCCESS);
}

/****************************************************************************
 *  OnPnpNewDevnode
 *                      This procedure gets called when a new devnode
 *                        has been created (PNP_NEW_DEVNODE)
 *
 *  Exported.
 *
 *  ENTRY:  DevNode is the new devnode that has just been created.
 *
 *      LoadType is the type of functionality configuration manager
 *      (or a devloader) wants this DLVxD to handle. It can be
 *      devloader, driver or enumerator.
 *
 *  EXIT:   Standard config manager return value.
 *
 ***************************************************************************/
CONFIGRET CM_SYSCTRL OnPnpNewDevnode(DEVNODE Devnode, LOAD_TYPE LoadType)
{
	switch ( LoadType ){
	case DLVXD_LOAD_DEVLOADER:
		// Enumerator ̓o^KvȂs
		// CM_Register_Enumerator( Devnode, enumerator, CM_REGISTER_ENUMERATOR_HARDWARE);

		// ޲ײނ̓o^
		return CM_Register_Device_Driver(Devnode, OnConfigure, 0, CM_REGISTER_DEVICE_DRIVER_REMOVABLE);
	}
	return(CR_DEFAULT);
}

